package build

import (
	"git.akyoto.dev/cli/q/src/build/expression"
	"git.akyoto.dev/cli/q/src/errors"
)

// CompileAssignment compiles an assignment.
func (f *Function) CompileAssignment(expr *expression.Expression) error {
	name := expr.Children[0].Token.Text()
	variable, exists := f.Variables[name]

	if !exists {
		return errors.New(&errors.UnknownIdentifier{Name: name}, f.File, expr.Children[0].Token.Position)
	}

	if expr.Token.Text() == "=" {
		return f.ExpressionToRegister(expr.Children[1], variable.Register)
	}

	right := expr.Children[1]

	if right.IsLeaf() {
		return f.Calculate(variable.Register, expr.Token, right.Token)
	}

	return f.Execute(expr.Token, variable.Register, expr.Children[1])
}
